#include <Windows.h>
#include <stdio.h>
#include "myfunc.h"
/*********************************

  t@C[Ƀ[h

**********************************/
BOOL AllocateFileMemory(LPCTSTR lpFile,FILEMEMORYINFO *psFMInfo)
{
	HANDLE hFile;
	BOOL blRet=FALSE;
	DWORD dwSizeHigh;
	
	hFile=CreateFile(lpFile,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	if(hFile==INVALID_HANDLE_VALUE) return blRet;
	
	psFMInfo->dwFileSize=GetFileSize(hFile,&dwSizeHigh);
	if(psFMInfo->dwFileSize == 0xFFFFFFFF
		&& NO_ERROR != GetLastError()){
		goto error;
	}
	else if(dwSizeHigh){
		goto error;
	}

	psFMInfo->lpPointer=HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY|HEAP_NO_SERIALIZE,psFMInfo->dwFileSize);
	if(psFMInfo->lpPointer){
		if(ReadFile(hFile,psFMInfo->lpPointer,psFMInfo->dwFileSize,&psFMInfo->dwFileSize,NULL))
			blRet=TRUE;
	}
error:
	CloseHandle(hFile);
	return blRet;
}

void FreeFileMemory(FILEMEMORYINFO *psFMInfo)
{
	if(psFMInfo->lpPointer)
		HeapFree(GetProcessHeap(),HEAP_NO_SERIALIZE,psFMInfo->lpPointer);
	ZeroMemory(psFMInfo,sizeof(FILEMEMORYINFO));
}

/****************************

  t@C̊gqύX

*****************************/
int ChangeFileExtention(char *pSourceName,char *pDestName,int iDestBufSize,char *pNewExt)
{
	int con,Tmp;

	memset(pDestName,0,iDestBufSize);
	// 
	//-------------
	for(con=0;con<iDestBufSize;con++){
		if(*(pSourceName+con)=='\0') break;
	}

	Tmp=con;

	for(;;)
	{
		if(!con){//no file extention
			con=Tmp;
			break;
		}
		if(*(pSourceName+con)=='.') break;
		con--;
	}
	memcpy(pDestName,pSourceName,con);
	if(lstrcmp(pNewExt,"")) {
		pDestName[con]='.';
		memcpy(pDestName+con+1,pNewExt,strlen(pNewExt));
	}
	else {
		pDestName[con]='\0';
	}
	return 0;
}

void GetFileExtention(TCHAR* lpFile,LPTSTR lpBuf,int iDestBufSize)
{
	int n;

	for(n=strlen(lpFile);n>0;n--){
		if(lpFile[n-1]=='.') break;
	}

	if(n)
		wsprintf(lpBuf,"%s",&lpFile[n]);
	else
		wsprintf(lpBuf,"\0");
}

void GetFileNameFromFullPath(TCHAR* lpFile,LPTSTR lpBuf,int iDestBufSize)
{
	int n;

	for(n=strlen(lpFile);n>0;n--){
		if(lpFile[n-1]=='\\') break;
	}

	wsprintf(lpBuf,"%s",&lpFile[n]);
}

int MakeFullPathName(LPCTSTR lpDir,LPCTSTR lpFile,LPTSTR lpBuf)
{
	int n,i;
	TCHAR tcTmp='\0';
	
	//Clear buffer
	if(lpDir!=lpBuf) memset(lpBuf,0,MAX_PATH*sizeof(TCHAR));

	//
	
	for(n=0;n<MAX_PATH;n++){
		if(lpDir[n]=='\0'){
			if(tcTmp!='\\') lpBuf[n++]='\\';
			break;
		}
		lpBuf[n]=lpDir[n];
		tcTmp=lpDir[n];
	}

	i=0;
	for(;n<MAX_PATH;n++,i++){
		if(lpFile[i]=='\0') break;
		lpBuf[n]=lpFile[i];
	}
	
	lpBuf[n]='\0';

	return n;
}

BOOL CheckFileExistance(LPTSTR lpFile)
{
	return (0xFFFFFFFF != GetFileAttributes(lpFile)) ? TRUE : FALSE;
}

/***********************************************

  vO̒uĂfBNg擾

************************************************/
int GetAppPathName(LPTSTR lpBuffer,int iBufferSize,LPTSTR lpFileName)
{
	TCHAR FullPath[MAX_PATH];
	LPTSTR lpCmdLine;
	int iCopySize;
	int iDirNameSize;//JgfBNg̖ÕTCY
	int iFileNameSize;//

	if(!lpBuffer) return 0;
	
	lpCmdLine = GetCommandLine();

	while(*lpCmdLine == '"') lpCmdLine++;
	for(iDirNameSize = 0;;iDirNameSize++) {
		if((*(lpCmdLine + iDirNameSize) == '\0')
			||(*(lpCmdLine + iDirNameSize) == '"')
			||(*(lpCmdLine + iDirNameSize)==' ')) {
			memcpy(FullPath, lpCmdLine, iDirNameSize * sizeof(TCHAR));
			FullPath[iDirNameSize] = 0;
			if(CheckFileExistance(FullPath))
				break;
		}
	}

	for(;iDirNameSize >= 0;iDirNameSize--)if(*(lpCmdLine + iDirNameSize - 1) == '\\')break;

	if(lpFileName)
	{
		for(iFileNameSize = 0;;iFileNameSize++) {
			if(*(lpFileName + iFileNameSize) == '\0')
				break;
		}
	}
	else
		iFileNameSize = 0;

	memcpy(FullPath, lpCmdLine, iDirNameSize * sizeof(TCHAR));
	FullPath[iDirNameSize] = 0;
	if(lpFileName) memcpy(FullPath + iDirNameSize, lpFileName, iFileNameSize);

	iCopySize = (iBufferSize < iDirNameSize + iFileNameSize) ? iBufferSize : iDirNameSize + iFileNameSize;

	memcpy(lpBuffer, FullPath, iCopySize * sizeof(TCHAR));
	lpBuffer[iCopySize] = 0;

	return iCopySize;
}
